var lPregunta=0

function onImage(e){
_pieceWidth = Math.floor(_img.width / PUZZLE_DIFFICULTY)
_pieceHeight = Math.floor(_img.height / PUZZLE_DIFFICULTY)
_puzzleWidth = _pieceWidth * PUZZLE_DIFFICULTY;
_puzzleHeight = _pieceHeight * PUZZLE_DIFFICULTY;
setCanvas();
initPuzzle();
document.getElementById("menini").style.visibility="hidden";
}
function setCanvas(){
_canvas = document.getElementById('canvas');
_stage = _canvas.getContext('2d');
_canvas.width = _puzzleWidth;
_canvas.height = _puzzleHeight;
_canvas.style.border = "1px solid blue";
}
function initPuzzle(){
_pieces = [];
_mouse = {x:0,y:0};
_currentPiece = null;
_currentDropPiece = null;
_stage.drawImage(_img, 0, 0, _puzzleWidth, _puzzleHeight, 0, 0, _puzzleWidth, _puzzleHeight);
if (document.getElementById("img_res")){
	if (trim(apreguntas[0])>"" && trim(arespuestas[0])>""){
			lPregunta=1
			document.getElementById("ta00").innerHTML=apreguntas[0]
	}
}
document.getElementById("tx00").innerHTML=apalabras[0]
//createTitle("Haz click para empezar el puzzle");
document.getElementById("describe").innerHTML="&nbsp;Haz click para empezar el puzzle&nbsp;";
buildPieces();
}
function createTitle(msg){
_stage.fillStyle = "#000000";
_stage.globalAlpha = .4;
_stage.fillRect(100,_puzzleHeight - 40,_puzzleWidth - 200,40);
_stage.fillStyle = "#FFFFFF";
_stage.globalAlpha = 1;
_stage.textAlign = "center";
_stage.textBaseline = "middle";
_stage.font = "20px Arial";
_stage.fillText(msg,_puzzleWidth / 2,_puzzleHeight - 20);
}
function buildPieces(){
var i;
var piece;
var xPos = 0;
var yPos = 0;
for(i = 0;i < PUZZLE_DIFFICULTY * PUZZLE_DIFFICULTY;i++){
piece = {};
piece.sx = xPos;
piece.sy = yPos;
_pieces.push(piece);
xPos += _pieceWidth;
if(xPos >= _puzzleWidth){
xPos = 0;
yPos += _pieceHeight;
}
}
if (ayuda==1){
	document.onmousedown = shufflePuzzle;
}
else{
	shufflePuzzle()
}
}
function shufflePuzzle(){
document.getElementById("describe").innerHTML="&nbsp;Pulsa sobre las piezas y arr&aacute;stralas al lugar adecuado&nbsp;";
cargaCronometro()
_pieces = shuffleArray(_pieces);
_stage.clearRect(0,0,_puzzleWidth,_puzzleHeight);
var i;
var piece;
var xPos = 0;
var yPos = 0;
for(i = 0;i < _pieces.length;i++){
piece = _pieces[i];
piece.xPos = xPos;
piece.yPos = yPos;
_stage.drawImage(_img, piece.sx, piece.sy, _pieceWidth, _pieceHeight, xPos, yPos, _pieceWidth, _pieceHeight);
_stage.strokeRect(xPos, yPos, _pieceWidth,_pieceHeight);
xPos += _pieceWidth;
if(xPos >= _puzzleWidth){
xPos = 0;
yPos += _pieceHeight;
}
}
document.onmousedown = onPuzzleClick;
}
function onPuzzleClick(e){
if(e.layerX || e.layerX == 0){
_mouse.x = e.layerX - _canvas.offsetLeft;
_mouse.y = e.layerY - _canvas.offsetTop;
}
else if(e.offsetX || e.offsetX == 0){
_mouse.x = e.offsetX - _canvas.offsetLeft;
_mouse.y = e.offsetY - _canvas.offsetTop;
}
_currentPiece = checkPieceClicked();
if(_currentPiece != null){
_stage.clearRect(_currentPiece.xPos,_currentPiece.yPos,_pieceWidth,_pieceHeight);
_stage.save();
_stage.globalAlpha = .9;
_stage.drawImage(_img, _currentPiece.sx, _currentPiece.sy, _pieceWidth, _pieceHeight, _mouse.x - (_pieceWidth / 2), _mouse.y - (_pieceHeight / 2), _pieceWidth, _pieceHeight);
_stage.restore();
document.onmousemove = updatePuzzle;
document.onmouseup = pieceDropped;
}
}
function checkPieceClicked(){
var i;
var piece;
for(i = 0;i < _pieces.length;i++){
piece = _pieces[i];
if(_mouse.x < piece.xPos || _mouse.x > (piece.xPos + _pieceWidth) || _mouse.y < piece.yPos || _mouse.y > (piece.yPos + _pieceHeight)){
//PIECE NOT HIT
}
else{
return piece;
}
}
return null;
}
function updatePuzzle(e){
_currentDropPiece = null;
if(e.layerX || e.layerX == 0){
_mouse.x = e.layerX - _canvas.offsetLeft;
_mouse.y = e.layerY - _canvas.offsetTop;
}
else if(e.offsetX || e.offsetX == 0){
_mouse.x = e.offsetX - _canvas.offsetLeft;
_mouse.y = e.offsetY - _canvas.offsetTop;
}
_stage.clearRect(0,0,_puzzleWidth,_puzzleHeight);
var i;
var piece;
for(i = 0;i < _pieces.length;i++){
piece = _pieces[i];
if(piece == _currentPiece){
continue;
}
_stage.drawImage(_img, piece.sx, piece.sy, _pieceWidth, _pieceHeight, piece.xPos, piece.yPos, _pieceWidth, _pieceHeight);
_stage.strokeRect(piece.xPos, piece.yPos, _pieceWidth,_pieceHeight);
if(_currentDropPiece == null){
if(_mouse.x < piece.xPos || _mouse.x > (piece.xPos + _pieceWidth) || _mouse.y < piece.yPos || _mouse.y > (piece.yPos + _pieceHeight)){
//NOT OVER
}
else{
_currentDropPiece = piece;
_stage.save();
_stage.globalAlpha = .4;
_stage.fillStyle = PUZZLE_HOVER_TINT;
_stage.fillRect(_currentDropPiece.xPos,_currentDropPiece.yPos,_pieceWidth, _pieceHeight);
_stage.restore();
}
}
}
_stage.save();
_stage.globalAlpha = .6;
_stage.drawImage(_img, _currentPiece.sx, _currentPiece.sy, _pieceWidth, _pieceHeight, _mouse.x - (_pieceWidth / 2), _mouse.y - (_pieceHeight / 2), _pieceWidth, _pieceHeight);
_stage.restore();
_stage.strokeRect( _mouse.x - (_pieceWidth / 2), _mouse.y - (_pieceHeight / 2), _pieceWidth,_pieceHeight);
}
function pieceDropped(e){
document.onmousemove = null;
document.onmouseup = null;
if(_currentDropPiece != null){
var tmp = {xPos:_currentPiece.xPos,yPos:_currentPiece.yPos};
_currentPiece.xPos = _currentDropPiece.xPos;
_currentPiece.yPos = _currentDropPiece.yPos;
_currentDropPiece.xPos = tmp.xPos;
_currentDropPiece.yPos = tmp.yPos;
}
resetPuzzleAndCheckWin();
}
function resetPuzzleAndCheckWin(){
_stage.clearRect(0,0,_puzzleWidth,_puzzleHeight);
var gameWin = true;
var i;
var piece;
var nBien=0;
for(i = 0;i < _pieces.length;i++){
piece = _pieces[i];
_stage.drawImage(_img, piece.sx, piece.sy, _pieceWidth, _pieceHeight, piece.xPos, piece.yPos, _pieceWidth, _pieceHeight);
_stage.strokeRect(piece.xPos, piece.yPos, _pieceWidth,_pieceHeight);
if(piece.xPos != piece.sx || piece.yPos != piece.sy){
gameWin = false;
}
else {
nBien++;
}
}
document.getElementById("fichabien").innerHTML=nBien;
if(gameWin){
setTimeout(gameOver,500);
}
}
function gameOver(){
document.onmousedown = null;
document.onmousemove = null;
document.onmouseup = null;
endPuzzle();
}
function shuffleArray(o){
for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
return o;
}

function endPuzzle(){
_pieces = [];
_mouse = {x:0,y:0};
_currentPiece = null;
_currentDropPiece = null;
_stage.clearRect(0,0,_puzzleWidth,_puzzleHeight);
_stage.drawImage(_img, 0, 0, _puzzleWidth, _puzzleHeight, 0, 0, _puzzleWidth, _puzzleHeight);
//createTitle("Muy bien! Lo has conseguido");
clearInterval(cronometro);
puntua()
//buildPieces();
}
function puntua(){
     if (document.getElementById("act_total")){ntotal=parseInt(document.getElementById("act_total").value)}
     nsegundos=parseInt(document.getElementById("segundos").innerHTML)+parseInt(document.getElementById("minutos").innerHTML)*10
     ntiempolimite=PUZZLE_DIFFICULTY*10
     npenaliza=(ntiempolimite-nsegundos)*0.15
     nPuntos=parseInt(ntotal+npenaliza)
     if (nPuntos<0){nPuntos=0;}
     document.getElementById("act_ptos").value=nPuntos
     document.getElementById("puntos").value=nPuntos
     cMensaje="&nbsp;Muy bien. Pulsa en el sobre para guardar los puntos&nbsp;"
     if (lPregunta>0){
     	     if (!lsolucion){
     	     	     cMensaje="&nbsp;Muy bien. Contesta a la PREGUNTA debajo y pulsa en el sobre para guardar los puntos&nbsp;"
     	     }
     }
     document.getElementById("describe").innerHTML=cMensaje;
     document.getElementById("bonos").innerHTML=npenaliza.toFixed(2);
}

function grabar(){
if (nEnviado==0){
	//cUsuario=document.getElementById("act_log").value
	cUsuario=document.getElementById("act_log").value
	if (lPregunta>0){
		comprueba()
		if (lsolucion){
			if (window.confirm("¿Grabar la actividad? "+cUsuario)===true){	
				document.actividad.submit()
				if (document.getElementById('iframeUpload')){
					var iframe = document.getElementById('iframeUpload');
				}
				document.getElementById("grabar").src="images/mail-forward-off.png"
				document.getElementById("grabar").src="images/mail-forward-off.png"
				nEnviado=1
			}
		}
		else {
			window.alert("Responde primero a la pregunta")
		}
	}
	else{
		if (window.confirm("¿Grabar la actividad? "+cUsuario)===true){	
			document.actividad.submit()
			if (document.getElementById('marcoCarga')){
				var iframe = document.getElementById('marcoCarga');
			}
			document.getElementById("grabar").src="images/mail-forward-off.png"
			nEnviado=1
		}
	}
   }
}

function comprueba(){
  var lBien=false
  if (lPregunta>0){
	  cSlc=arespuestas[0]
	  aSlc=cSlc.split("-")
	  nTrt=aSlc.length
	  SOLC=""
	  for (nTr=0;nTr<nTrt;nTr++){
		  SOLC+="(?=.*("+aSlc[nTr]+")"+"\\W)"
	  }
	  SOLC=trim(SOLC)
	  RESP=document.getElementById("prg_res").value+" "
	  if (SOLC.toUpperCase()==RESP.toUpperCase()){
	      lBien=true
	  }  
	  else{
	      cExpresion=SOLC
	      cExpresion=replaceAll(cExpresion,",","|")
	      var cExp = new RegExp(cExpresion,"i")
	      if (RESP.match(cExp)){lBien=true}
	  }
	  if (lBien){document.getElementById("img_res").src="images/test-ok.png"}
	  else {document.getElementById("img_res").src="images/process-stop.png"}
	  lsolucion=lBien
	  return (lBien)
  }
}

function cargaCronometro(){
        contador_s =0;
        contador_m =0;
        s = document.getElementById("segundos");
        m = document.getElementById("minutos");
        cronometro = setInterval(
        function(){
        	nsegundos=parseInt(document.getElementById("segundos").innerHTML)+parseInt(document.getElementById("minutos").innerHTML)*10
        	ntiempolimite=PUZZLE_DIFFICULTY*10
        	npenaliza=(ntiempolimite-nsegundos)*0.15
        	document.getElementById("bonos").innerHTML=npenaliza.toFixed(2);
                if(contador_s==60){
                    contador_s=0;
                    contador_m++;
                    m.innerHTML = contador_m;
                    if(contador_m==60){
                        contador_m=0;
                    }
                }
                s.innerHTML = contador_s;
                contador_s++;
            }
            ,1000);
}

//************************************************
//* FUNCIONES GENERALES                          *
//************************************************

function estaen(cad,ter) {
pos=-1
lng=cad.length
lnt=ter.length
for (con=0;con+lnt-1<lng;++con) {
if (cad.substring(con,con+lnt)==ter) {
pos=con
return (pos);
}
}
return (pos);
}

function estaenarray(nomarr,datos){
nposicion=-1
nelementos=eval(nomarr+".length")
for (neleact=0;neleact<nelementos;++neleact){
	celemento=eval(nomarr+"["+neleact+"]")
	nposicion=estaen(celemento,datos)
	if (nposicion>-1){
		return (neleact)
		}
	}
return (-1)
}

function cambiacadena(pal,ori,des) {
nLp=pal.length
orb=ori
nLo=orb.length
nSd=estaen(pal,orb)
nLo=orb.length
if (nSd>-1){
	pal=pal.substring(0,nSd)+des+pal.substring(nSd+nLo)
	pal=cambiacadena(pal,ori,des)
}
return (pal)
}

function cambiauna(pal,ori,des) {
nLp=pal.length
orb=ori
nLo=orb.length
nSd=estaen(pal,orb)
nLo=orb.length
if (nSd>-1){
	pal=pal.substring(0,nSd)+des+pal.substring(nSd+nLo)
}
return (pal)
}

function rellena(caracter,veces){
var crelleno=""
for (nlonact=1;nlonact<=veces;++nlonact){
	crelleno=crelleno+caracter
}
return (crelleno)
}


function daazar(valormax) {
  var ahora = new Date()
  var nazar = ahora.getTime() * ahora.getSeconds() * Math.random()
  return Math.round(nazar % valormax)
}

function replaceAll( texto, busca, reemplaza ){
         return texto.split(busca).join(reemplaza)
}

function descarga(){
  document.forms["frPDF"].submit();
}

Array.prototype.shuffle = function() {
    for ( var i = this.length-1; i > 0; i-- ) {
        var j = Math.floor( i * Math.random() );
        var tmp = this[ j ];
        this[ j ] = this[ i ];
        this[ i ] = tmp;
    }
    return this;
}

function trim(cadena){
    if (cadena){
	return rtrim(ltrim(cadena))
    }
    else{
    	return ""    
    }
	 
}

function ltrim (cadena){
	return cadena.replace( /^\s*/, "" );
}

function rtrim (cadena){
	return cadena.replace( /\s*$/, "" );
}

function ocultaAyuda(){
    document.getElementById("ayuda").style.visibility="hidden"
    document.getElementById("mascara").style.visibility="hidden"
}

function verdiv(cnomdiv) {
	if (document.getElementById){
		document.getElementById(cnomdiv).style.visibility="visible"
	}
	if(document.all) {
		document.all[cnomdiv].style.visibility="visible"
	} 
	if(document.layers) {
		document.layers[cnomdiv].visibility="visible"
	}
}

function ocudiv(cnomdiv) {
	if (document.getElementById){
		document.getElementById(cnomdiv).style.visibility="hidden"
	}
	else {
		if(document.all) {
			document.all(cnomdiv).style.visibility="hidden"
		}
		else {
			if(document.layers) {
				document.layers[cnomdiv].visibility="hidden"
			}
		}
	}
}

